summaryrefslogtreecommitdiff
path: root/plugins/colorize/colorize.plugin.zsh
diff options
context:
space:
mode:
authorTuowen Zhao <ztuowen@gmail.com>2019-09-11 18:19:51 -0600
committerTuowen Zhao <ztuowen@gmail.com>2019-09-11 18:19:51 -0600
commitd676c1553254309beca5bb9a8edb43fbe09a7169 (patch)
treed0bb04b6487e6fedbb2b2370a894fccd19d4c567 /plugins/colorize/colorize.plugin.zsh
parentfb141c2257f648cd29b64cbd3f2ca9123f6e427f (diff)
parentddd359dd668f448856438304bedfe952d1749efd (diff)
downloadzsh-d676c1553254309beca5bb9a8edb43fbe09a7169.tar.gz
zsh-d676c1553254309beca5bb9a8edb43fbe09a7169.tar.bz2
zsh-d676c1553254309beca5bb9a8edb43fbe09a7169.zip
Merge remote-tracking branch 'orig/master'
Diffstat (limited to 'plugins/colorize/colorize.plugin.zsh')
-rw-r--r--plugins/colorize/colorize.plugin.zsh37
1 files changed, 33 insertions, 4 deletions
diff --git a/plugins/colorize/colorize.plugin.zsh b/plugins/colorize/colorize.plugin.zsh
index 8eede9a94..565ba5a36 100644
--- a/plugins/colorize/colorize.plugin.zsh
+++ b/plugins/colorize/colorize.plugin.zsh
@@ -1,5 +1,6 @@
# easier alias to use the plugin
alias ccat='colorize_via_pygmentize'
+alias cless='colorize_via_pygmentize_less'
colorize_via_pygmentize() {
if ! (( $+commands[pygmentize] )); then
@@ -7,22 +8,50 @@ colorize_via_pygmentize() {
return 1
fi
+ # If the environment varianle ZSH_COLORIZE_STYLE
+ # is set, use that theme instead. Otherwise,
+ # use the default.
+ if [ -z $ZSH_COLORIZE_STYLE ]; then
+ ZSH_COLORIZE_STYLE="default"
+ fi
+
# pygmentize stdin if no arguments passed
if [ $# -eq 0 ]; then
- pygmentize -g
+ pygmentize -O style="$ZSH_COLORIZE_STYLE" -g
return $?
fi
# guess lexer from file extension, or
# guess it from file contents if unsuccessful
+
local FNAME lexer
- for FNAME in $@
+ for FNAME in "$@"
do
lexer=$(pygmentize -N "$FNAME")
if [[ $lexer != text ]]; then
- pygmentize -l "$lexer" "$FNAME"
+ pygmentize -O style="$ZSH_COLORIZE_STYLE" -l "$lexer" "$FNAME"
else
- pygmentize -g "$FNAME"
+ pygmentize -O style="$ZSH_COLORIZE_STYLE" -g "$FNAME"
fi
done
}
+
+colorize_via_pygmentize_less() (
+ # this function is a subshell so tmp_files can be shared to cleanup function
+ declare -a tmp_files
+
+ cleanup () {
+ [[ ${#tmp_files} -gt 0 ]] && rm -f "${tmp_files[@]}"
+ exit
+ }
+ trap 'cleanup' EXIT HUP TERM INT
+
+ while (( $# != 0 )); do #TODO: filter out less opts
+ tmp_file="$(mktemp -t "tmp.colorize.XXXX.$(sed 's/\//./g' <<< "$1")")"
+ tmp_files+=("$tmp_file")
+ colorize_via_pygmentize "$1" > "$tmp_file"
+ shift 1
+ done
+
+ less -f "${tmp_files[@]}"
+)